Issue 4252

Title
Adding invisible buttons in tree views to get them in action menu
Priority
feature
Status
in-progress
Nosy list
ced, jesteve, pokoli, resteve, reviewbot, roundup-bot, semarie
Assigned to
jesteve
Keywords
patch, review

Created on 2014-10-15.12:29:29 by jesteve, last changed 2 months ago by pokoli.

Files

File name Uploaded Type Details
account_invoice.patch jesteve, 2015-01-27.17:38:28 text/plain view

Messages

New changeset 3dbc554cc278 by Cédric Krier in branch 'default':
Add post action in statement tree view
https://hg.tryton.org/tryton-env/rev/3dbc554cc278
New changeset 26fa3b0a0196 by Sebastien Marie in branch 'default':
Add post action in statement tree view
https://hg.tryton.org/modules/account_statement/rev/26fa3b0a0196
New changeset f40a8d438d40 by Jordi Esteve in branch 'default':
Add buttons on move tree view
http://hg.tryton.org/modules/account/rev/f40a8d438d40
Author: [hidden] (jesteve)
Date: 2015-02-20.18:29:32
> Cédric Krier <cedric.krier@b2ck.com> added the comment:
>
>
> That's why you don't understand my argument. Less choice to the user
> lead to a better user experience.
> Putting all the buttons every where will lead to a complex user
> interface which will not help at all the user.

Ok, I will follow your advice and I will resend the codereviews removing 
the actions that are weird to be execute to several records at once.

But as my criteria will be different of yours, it will be helpful if you 
point in each of the 6 remaining reviews which actions are no 
appropriated, if any.
Author: [hidden] (ced) Tryton committer Tryton translator
Date: 2015-02-20.18:05:08
On 20 Feb 17:40, Jordi Esteve wrote:
> > Cédric Krier <cedric.krier@b2ck.com> added the comment:
> >
> > On 20 Feb 13:52, Jordi Esteve wrote:
> >>> reviews, I have always the same concern. For me, most of the changes
> >>> don't have a usage for normal workflow. So I stopped reviewing them.
> >>> Did you think about what will be the usage of it? Or just just
> >>> duplicate all the form button to the list view?
> >> The usage is to perform the actions, also for a single record, in the
> >> list view without going to the form view.
> > For me, it is not a valid reason.
> 
> Why? Could you argue because it is not a valid reason?
> 
> Allowing to execute the actions in tree view and form view gives more 
> flexibility to the user.

This is not always better for the UX.

> Moreover, the usability of the records 
> management is more coherent, the behaviour is similar to the delete 
> action, you can delete one record in form view and one or more records 
> in tree view.
> 
> For example, in fiscal years, your say "You never close many fiscal year 
> at once.". Also "You never delete many fiscal year at once.", so we must 
> remove the delete action in tree view?

Please feel free to provide a patch to issue1639.

> Moreover, it is very difficult decide which actions have no sense to 
> execute in several records at once. Close several fiscal years at once 
> no, Open several fiscal years at once yes?

Of course each case must be discussed individually.

> I don't see a problem giving 
> the choice to the final user.

That's why you don't understand my argument. Less choice to the user
lead to a better user experience.
Putting all the buttons every where will lead to a complex user
interface which will not help at all the user.
Author: [hidden] (jesteve)
Date: 2015-02-20.17:40:10
> Cédric Krier <cedric.krier@b2ck.com> added the comment:
>
> On 20 Feb 13:52, Jordi Esteve wrote:
>>> reviews, I have always the same concern. For me, most of the changes
>>> don't have a usage for normal workflow. So I stopped reviewing them.
>>> Did you think about what will be the usage of it? Or just just
>>> duplicate all the form button to the list view?
>> The usage is to perform the actions, also for a single record, in the
>> list view without going to the form view.
> For me, it is not a valid reason.

Why? Could you argue because it is not a valid reason?

Allowing to execute the actions in tree view and form view gives more 
flexibility to the user. Moreover, the usability of the records 
management is more coherent, the behaviour is similar to the delete 
action, you can delete one record in form view and one or more records 
in tree view.

For example, in fiscal years, your say "You never close many fiscal year 
at once.". Also "You never delete many fiscal year at once.", so we must 
remove the delete action in tree view?

Moreover, it is very difficult decide which actions have no sense to 
execute in several records at once. Close several fiscal years at once 
no, Open several fiscal years at once yes? I don't see a problem giving 
the choice to the final user.
Author: [hidden] (ced) Tryton committer Tryton translator
Date: 2015-02-20.14:15:08
On 20 Feb 13:52, Jordi Esteve wrote:
> > reviews, I have always the same concern. For me, most of the changes 
> > don't have a usage for normal workflow. So I stopped reviewing them. 
> > Did you think about what will be the usage of it? Or just just 
> > duplicate all the form button to the list view?
> 
> The usage is to perform the actions, also for a single record, in the 
> list view without going to the form view.

For me, it is not a valid reason.
Author: [hidden] (jesteve)
Date: 2015-02-20.13:52:46
> Cédric Krier <cedric.krier@b2ck.com> added the comment: After few 
> reviews, I have always the same concern. For me, most of the changes 
> don't have a usage for normal workflow. So I stopped reviewing them. 
> Did you think about what will be the usage of it? Or just just 
> duplicate all the form button to the list view?

The usage is to perform the actions, also for a single record, in the 
list view without going to the form view.

Not all form buttons have been duplicated to the list views. Buttons 
that executes a wizard to perform an action to a single record have not 
been added, for example pay an invoice, because it has no sense execute 
this wizard over serveral records.
Author: [hidden] (ced) Tryton committer Tryton translator
Date: 2015-02-20.11:35:44
After few reviews, I have always the same concern.
For me, most of the changes don't have a usage for normal workflow.
So I stopped reviewing them.
Did you think about what will be the usage of it? Or just just duplicate all the form button to the list view?
Author: [hidden] (ced) Tryton committer Tryton translator
Date: 2015-02-20.11:26:17
Please add missing issue reference in all your reviews.
Author: [hidden] (jesteve)
Date: 2015-02-17.20:26:47
Invisible buttons in tree views are defined in account_invoice, account_payment and commission but they are missing in these other modules. Reviews attached add them.

account
account_asset
account_payment_sepa
account_statement
production
purchase
sale
sale_opportunity
sale_supply_drop_shipment
stock
stock_forecast
New changeset 03ba84b06a30 by C?dric Krier in branch 'default':
Remove icon attribute on button in tree view
http://hg.tryton.org/modules/account_invoice/rev/03ba84b06a30
Author: [hidden] (ced) Tryton committer Tryton translator
Date: 2015-01-29.12:11:44
Your patch fails badly: https://drone.tryton.org/trypod.tryton.org/tryton/modules.account_invoice/default/1478ce5f2c25

Please ***TEST*** your patches!!!
New changeset 1478ce5f2c25 by Jordi Esteve in branch 'default':
Adding invisible buttons in tree view to get them in action menu
http://hg.tryton.org/modules/account_invoice/rev/1478ce5f2c25
Author: [hidden] (jesteve)
Date: 2014-10-15.12:29:28
From tryton 3.2 there is a nice feature that allows to get the button actions in the action menu. Now in the most cases are only defined in form views, but it would be very useful defining them in tree views to be able to execute the button action to several records at the same time.

For example, in account_payment/view/move_line_list.xml file is defined:

    <button name="pay" string="Pay Lines" tree_invisible="1"/>

that allows to pay several move lines in tree view because the Pay Lines button appears in the action menu.

It would be useful adding these buttons in the tree views of account moves, invoices, sales, purchases, productions, projects, ... For example, in invoices, some of these buttons could be added in account_invoice/view/invoice_tree.xml:

    <button name="cancel" string="_Cancel" tree_invisible="1"
        icon="tryton-cancel"
        confirm="Are you sure to cancel the invoice?"/>
    <button name="draft" string="_Draft" tree_invisible="1"
        icon="tryton-go-previous"/>
    <button name="validate_invoice" string="Validate" tree_invisible="1"
        help="Also known as Pro Forma"
        icon="tryton-go-next"/>
    <button name="post" string="_Post" tree_invisible="1" icon="tryton-ok"/>
    <button name="pay" string="_Pay" tree_invisible="1" icon="tryton-go-next"/>
History
Date User Action Args
2020-10-22 11:16:08cedlinkissue9748 superseder
2020-09-12 18:28:58pokolisetstatus: resolved -> in-progress
2020-09-12 01:37:55roundup-botsetmessages: + msg60070
2020-09-12 01:37:52roundup-botsetstatus: chatting -> resolved
messages: + msg60069
2020-07-28 13:50:18reviewbotsetnosy: + reviewbot
messages: + msg59525
2020-07-28 13:50:18reviewbotsetreviews: 10821002,14021002,6921002,10981002,14031002,10991002,7951002,15041002,10241002,10251002,6911004,6091003 -> 10821002, 14021002, 6921002, 10981002, 14031002, 10991002, 7951002, 15041002, 10241002, 10251002, 6911004, 6091003, 294241002
2020-07-28 13:42:37semariesetnosy: + semarie
2020-07-28 12:21:18pokolisetnosy: + pokoli
2020-07-28 12:18:11cedsetstatus: testing -> chatting
2020-07-28 12:18:00cedsetstatus: resolved -> testing

Showing 10 items. Show all history (warning: this could be VERY long)